#drinc:libraries/dos.g
#drinc:util.g

uint
    MAX_LINE_LENGTH = 256,
    MAX_MATCH = 100;

[MAX_LINE_LENGTH] char LineBuffer;
unsigned MAX_LINE_LENGTH Position;
uint LineNumber, PatternLength;
*char Pattern;
channel input text Chin;
file(1000) Fyle;

proc checkLine()void:
    register *char p, q, r, endPos;
    register uint column;

    if Position >= PatternLength then
	LineBuffer[Position] := '\e';
	p := &LineBuffer[0];
	endPos := &LineBuffer[Position - PatternLength] + 1;
	while p ~= endPos do
	    q := p;
	    r := Pattern;
	    while q* = r* and r* ~= '\e' do
		q := q + 1;
		r := r + 1;
	    od;
	    if r* = '\e' then
		column := 1;
		r := &LineBuffer[0];
		while r ~= p do
		    column := if r* = '\t' then
				  (column + 7) & ~7 + 1
			      else
				  column + 1
			      fi;
		    r := r + 1;
		od;
		writeln(Chin, '(', LineNumber, ',', column, "): ",
			&LineBuffer[0]);
		p := endPos - 1;
	    fi;
	    p := p + 1;
	od;
    fi;
corp;

proc scanFile()void:
    char ch;

    PatternLength := CharsLen(Pattern);
    LineNumber := 1;
    Position := 0;
    while
	if not read(Chin; ch) then
	    if ioerror(Chin) = CH_MISSING then
		checkLine();
		readln(Chin;);
		LineNumber := LineNumber + 1;
		Position := 0;
		true
	    else
		false
	    fi
	else
	    LineBuffer[Position] := ch;
	    Position := Position + 1;
	    true
	fi
    do
    od;
corp;

proc processFile(*char fileName)void:

    if open(Chin, Fyle, fileName) then
	scanFile();
	close(Chin);
    else
	writeln("find: can't open \"", fileName, '\"');
    fi;
corp;

proc match(register *char pat, name)bool:
    register *char patBack, nameBack;
    bool matching, done;

    matching := true;
    done := false;
    patBack := nil;
    while matching and not done do
	if name* = '\e' then
	    while pat* = '*' do
		pat := pat + 1;
	    od;
	    if pat* ~= '\e' then
		matching := false;
	    fi;
	    done := true;
	else
	    case pat*
	    incase '\e':
		matching := false;
		done := true;
	    incase '?':
		pat := pat + 1;
		name := name + 1;
	    incase '*':
		while pat* = '*' do
		    pat := pat + 1;
		od;
		if pat* = '\e' then
		    done := true;
		else
		    while name* ~= pat* and name* ~= '\e' do
			name := name + 1;
		    od;
		    patBack := pat;
		    nameBack := name;
		    if name* = '\e' then
			matching := false;
		    fi;
		fi;
	    default:
		if pat* ~= name* then
		    if patBack ~= nil then
			pat := patBack;
			name := nameBack + 1;
			while name* ~= pat* and name* ~= '\e' do
			    name := name + 1;
			od;
			nameBack := name;
			if name* = '\e' then
			    matching := false;
			fi;
		    else
			matching := false;
			done := true;
		    fi;
		else
		    name := name + 1;
		    pat := pat + 1;
		fi;
	    esac;
	fi;
    od;
    matching
corp;

proc main()void:
    *FileInfoBlock_t fib;
    Lock_t lock;
    register *char par, p, q, r;
    bool res, matched;
    enum {colon, slash1, slash2, neither} state;
    char savedChar;

    par := GetPar();
    if par = nil then
	writeln("Use is: find string file1 ... filen");
	exit(1);
    fi;
    Pattern := par;
    par := GetPar();
    if par = nil then
	open(Chin);
	scanFile();
	close(Chin);
    else
	while par ~= nil do
	    p := par;
	    while p* ~= '\e' do
		p := p + 1;
	    od;
	    while
		p := p - 1;
		p ~= par and p* ~= '/' and p* ~= ':'
	    do
	    od;
	    q := p;
	    while q* ~= '\e' and q* ~= '*' and q* ~= '?' do
		q := q + 1;
	    od;
	    if q* = '\e' then
		/* no pattern encountered */
		processFile(par);
	    else
		/* we found a '*' or a '?' -> we have a filename pattern */
		if p* = '/' then
		    p* := '\e';
		    if p = par then
			state := slash1;
			p := p + 1;
			r := "/";
		    else
			state := slash2;
			p := p + 1;
			r := par;
		    fi;
		elif p* = ':' then
		    state := colon;
		    p := p + 1;
		    savedChar := p*;
		    p* := '\e';
		    r := par;
		else
		    state := neither;
		    r := "";
		fi;
		lock := Lock(r, ACCESS_READ);
		if lock = 0 then
		    writeln("find: can't lock directory \"", r, '\"');
		else
		    if state = colon then
			p* := savedChar;
		    fi;
		    matched := false;
		    fib := new(FileInfoBlock_t);
		    if Examine(lock, fib) then
			while ExNext(lock, fib) do
			    if fib*.fib_DirEntryType & 0x80000000 ~= 0 and
				    match(p, &fib*.fib_FileName[0]) then
				processFile(&fib*.fib_FileName[0]);
				matched := true;
			    fi;
			od;
		    fi;
		    free(fib);
		    if not matched then
			if state = slash1 or state = slash2 then
			    (p - 1)* := '/';
			fi;
			writeln("find: \"", par, "\": no match");
		    fi;
		    UnLock(lock);
		fi;
	    fi;
	    par := GetPar();
	od;
    fi;
corp;
