#drinc:exec/io.g
#drinc:devices/timer.g
#drinc:intuition/preferences.g
#drinc:util.g

Preferences_t Prefs;
[sizeof(Preferences_t) - PREF_EXTBYTES] byte ShortPrefs @ Prefs;

proc printTime(*char name; *timeval_t tv)void:

    write(name, '(', tv*.tv_secs, ',', tv*.tv_micro, ')');
corp;

proc printPrefs()void:
    register uint i;

    writeln("Font: ",
	if Prefs.pr_FontHeight = TOPAZ_EIGHTY then
	    "Topaz-80"
	elif Prefs.pr_FontHeight = TOPAZ_SIXTY then
	    "Topaz-60"
	else
	    "Unknown"
	fi
    );
    writeln("Printer port: ",
	if Prefs.pr_PrinterPort = PARALLEL_PRINTER then
	    "Parallel"
	elif Prefs.pr_PrinterPort = SERIAL_PRINTER then
	    "Serial"
	else
	    "Unknown"
	fi
    );
    writeln("Serial baud rate: ",
	case Prefs.pr_BaudRate
	incase BAUD_110:
	    "110"
	incase BAUD_300:
	    "300"
	incase BAUD_1200:
	    "1200"
	incase BAUD_2400:
	    "2400"
	incase BAUD_4800:
	    "4800"
	incase BAUD_9600:
	    "9600"
	incase BAUD_19200:
	    "19200"
	incase BAUD_MIDI:
	    "MIDI"
	default:
	    "Unknown"
	esac
    );
    printTime("Key repeat speed: ", &Prefs.pr_KeyRptSpeed);
    printTime("  repeat delay: ", &Prefs.pr_KeyRptDelay);
    writeln();
    printTime("Double click interval: ", &Prefs.pr_DoubleClick);
    writeln();
    writeln("Pointer: ", Prefs.pr_PointerMatrix[0], ", ",
			 Prefs.pr_PointerMatrix[1]);
    for i from 2 by 2 upto POINTERSIZE - 2 do
	writeln("         ", Prefs.pr_PointerMatrix[i] : b : -16,
		"  ", Prefs.pr_PointerMatrix[i + 1] : b : -16);
    od;
    writeln("         ", Prefs.pr_PointerMatrix[POINTERSIZE - 2], ", ",
			Prefs.pr_PointerMatrix[POINTERSIZE - 1]);
    writeln("XOffset: ", Prefs.pr_XOffset, "  YOffset: ", Prefs.pr_YOffset);
    writeln("Pointer colours: ", Prefs.pr_color17 : x : -3, ' ',
	    Prefs.pr_color18 : x : -3, ' ', Prefs.pr_color19 : x : -3,
	    "  Pointer Ticks: ", Prefs.pr_PointerTicks);
    writeln("WorkBench colours: ", Prefs.pr_color0 : x : -3, ' ',
	    Prefs.pr_color1 : x : -3, ' ', Prefs.pr_color2 : x : -3, ' ',
	    Prefs.pr_color3 : x : -3);
    writeln("View XOffset: ", Prefs.pr_ViewXOffset >> 4, ", ",
			      Prefs.pr_ViewXOffset & 0xf,
	    "  View Size: ", Prefs.pr_ViewYOffset >> 4, ", ",
			     Prefs.pr_ViewYOffset & 0xf,
	    "  InitX: ", Prefs.pr_ViewInitX,
	    "  InitY: ", Prefs.pr_ViewInitY);
    writeln("Enable CLI: ", Prefs.pr_EnableCLI);
    writeln("Printer Type: ", Prefs.pr_PrinterType,
	    "  File Name: ", Prefs.pr_PrinterFileName);
    writeln("  Pitch: ", Prefs.pr_PrintPitch,
	    "  Quality: ", Prefs.pr_PrintQuality,
	    "  Spacing: ", Prefs.pr_PrintSpacing,
	    "  Left Margin: ", Prefs.pr_PrintLeftMargin,
	    "  Right Margin: ", Prefs.pr_PrintRightMargin);
    writeln("  Image: ", Prefs.pr_PrintImage,
	    "  Aspect: ", Prefs.pr_PrintAspect,
	    "  Threshold: ", Prefs.pr_PrintThreshold,
	    "  Paper Size: ", Prefs.pr_PaperSize,
	    "  Length: ", Prefs.pr_PaperLength,
	    "  Type: ", Prefs.pr_PaperType);
    writeln("Serial R/W Bits: ", Prefs.pr_SerRWBits : x : -8,
	    "  Buffer: ", Prefs.pr_SerStopBuf,
	    "  Parity/HandShake: ", Prefs.pr_SerParShk : x : -8);
    writeln("Interlace: ", Prefs.pr_LaceWB, " = ",
	    if Prefs.pr_LaceWB = LACEWB then "ON" else "OFF" fi);
    writeln("Printer Work File Name: ", Prefs.pr_WorkName);
    writeln("sys_reserved1: ", Prefs.pr_sys_reserved1 : x : -2,
	    "  sys_reserved2: ", Prefs.pr_sys_reserved2 : x : -2);
    writeln("Print Flags: ", Prefs.pr_PrintFlags : x : -4,
	    "  Max Width: ", Prefs.pr_PrintMaxWidth,
	    "  Max Height: ", Prefs.pr_PrintMaxHeight,
	    "  Density: ", Prefs.pr_PrintDensity,
	    "  XOffset: ", Prefs.pr_PrintXOffset);
    writeln("WB Width: ", Prefs.pr_wb_Width,
	    "  Height: ", Prefs.pr_wb_Height,
	    "  Depth: ", Prefs.pr_wb_Depth);
    write("Extension: (", Prefs.pr_ext_bytes[0], "): ");
    for i from 1 upto Prefs.pr_ext_bytes[0] do
	write(Prefs.pr_ext_bytes[i] : x : -2);
    od;
    writeln();
corp;

proc main()void:
    channel input binary chin;
    file() fyle;
    *char par;
    register uint i;
    ushort size;

    par := GetPar();
    if par = nil then
	writeln("Use is: printPrefs file-name\n");
    else
	if not open(chin, fyle, par) then
	    writeln("Can't open file '", par, "'.");
	else
	    if read(chin; ShortPrefs) then
		if read(chin; size) then
		    Prefs.pr_ext_bytes[0] := size;
		    i := 1;
		    while i <= size and read(chin; Prefs.pr_ext_bytes[i]) do
			i := i + 1;
		    od;
		    if ioerror(chin) ~= CH_OK then
			writeln("Warning: unable to read full extended "
				"preferences from file '", par, "'!");
		    fi;
		else
		    Prefs.pr_ext_bytes[0] := 0;
		fi;
		printPrefs();
	    else
		writeln("Couldn't read preferences from '", par, "'.");
	    fi;
	    close(chin);
	fi;
    fi;
corp;
