#drinc:exec/miscellaneous.g
#drinc:exec/nodes.g
#drinc:exec/ports.g
#drinc:exec/tasks.g
#drinc:exec/io.g
#drinc:exec/memory.g
#drinc:libraries/dos.g
#drinc:libraries/dosextens.g
#drinc:graphics/gfx.g
#drinc:graphics/view.g
#drinc:intuition/miscellaneous.g
#drinc:intuition/window.g
#drinc:util.g

/*
 * tbc.d - a very simple title-bar clock.
 */

proc runClock(register *Window_t w)void:
    register ulong titleLen, currentTime, rem;
    register *char oldTitle, newTitle;
    register bool first;

    oldTitle := w*.w_Title;
    titleLen := CharsLen(oldTitle);
    newTitle := AllocMem(titleLen + 50, MEMF_PUBLIC);
    first := true;
    if newTitle ~= nil then
	CharsCopy(newTitle, oldTitle);
	CharsConcat(newTitle, "  ");
	while SetSignal(0, SIGBREAKF_CTRL_C) & SIGBREAKF_CTRL_C = 0 do
	    currentTime := GetCurrentTime();
	    rem := currentTime % 60;
	    if w*.w_Title = newTitle or first then
		first := false;
		ConvTime(currentTime - rem,
			 newTitle + (titleLen + 2) * sizeof(char));
		SetWindowTitles(w, newTitle, nil);
	    fi;
	    if rem = 0 then
		Delay(60 * 50);
	    elif rem > 30 then
		Delay((60 - rem) * 50);
	    else
		Delay(rem * 50);
	    fi;
	od;
	SetWindowTitles(w, oldTitle, nil);
	FreeMem(newTitle, titleLen + 50);
    fi;
corp;

proc main()void:
    register *StandardPacket_t sp;
    register *MsgPort_t replyPort;
    register *InfoData_t id;
    *Process_t myProcess;
    *MsgPort_t mp;

    if OpenExecLibrary(33) ~= nil then
	if OpenDosLibrary(33) ~= nil then
	    if OpenGraphicsLibrary(33) ~= nil then
		if OpenIntuitionLibrary(33) ~= nil then
		    myProcess := pretend(FindTask(nil), *Process_t);
		    mp := pretend(myProcess*.pr_ConsoleTask, *MsgPort_t);
		    replyPort := CreatePort(nil, 0);
		    if replyPort ~= nil then
			sp := AllocMem(sizeof(StandardPacket_t),
				       MEMF_PUBLIC | MEMF_CLEAR);
			if sp ~= nil then
			    id := AllocMem(sizeof(InfoData_t),
					   MEMF_PUBLIC | MEMF_CLEAR);
			    if id ~= nil then
				sp*.sp_Msg.mn_Node.ln_Name :=
				    pretend(&sp*.sp_Pkt, *char);
				sp*.sp_Pkt.dp_Link := &sp*.sp_Msg;
				sp*.sp_Pkt.dp_Port := replyPort;
				sp*.sp_Pkt.dp_Type := ACTION_DISK_INFO;
				sp*.sp_Pkt.dp_Arg1 := pretend(id, ulong) >> 2;
				PutMsg(mp, &sp*.sp_Msg);
				ignore WaitPort(replyPort);
				ignore GetMsg(replyPort);
				runClock(pretend(id*.id_VolumeNode,
					 *Window_t));
				FreeMem(id, sizeof(InfoData_t));
			    fi;
			    FreeMem(sp, sizeof(StandardPacket_t));
			fi;
			DeletePort(replyPort);
		    fi;
		    CloseIntuitionLibrary();
		fi;
		CloseGraphicsLibrary();
	    fi;
	    CloseDosLibrary();
	fi;
	CloseExecLibrary();
    fi;
corp;
